[inherit('sys$library:pascal$lbr_routines','sys$library:starlet','common','psolr')]
program helpix(input,output);

const
   MAX_SUBTOPICS = 1000;
   MAX_PATHELMS = 10;
   MAX_QUEUEELMS = 10000;

type
   shortstring = varying [80] of char;
   help_context = record
                      nsubtopics : integer;
                      subtopics : array [1..MAX_SUBTOPICS] of shortstring;
                      helptext : varying [32000] of char;
                  end;
   path = record
             npathelms : integer;
             pathelms : array [1..MAX_PATHELMS] of shortstring;
          end;
   queue = record
              nqueueelms : integer;
              queueelms : array [1..MAX_QUEUEELMS] of path;
           end;

[ASYNCHRONOUS,EXTERNAL('LBR$GET_HELP')] FUNCTION LBR$GET_HELP_HACK (
        LIBRARY_INDEX : UNSIGNED;
        LINE_WIDTH : INTEGER := %IMMED 0;
        %IMMED [UNBOUND, ASYNCHRONOUS] FUNCTION ROUTINE(LINE:[CLASS_S] PACKED ARRAY[LOWER..UPPER:INTEGER] OF CHAR;
                                                        FLAG:INTEGER;
                                                        VAR CTX:HELP_CONTEXT;
                                                        LEVEL:INTEGER) : INTEGER := %IMMED 0;
        %REF DATA : [UNSAFE] ARRAY [$l4..$u4:INTEGER] OF CHAR := %IMMED 0;
        KEY_1 : [CLASS_S] PACKED ARRAY [$l5..$u5:INTEGER] OF CHAR := %IMMED 0;
        KEY_2 : [CLASS_S] PACKED ARRAY [$l6..$u6:INTEGER] OF CHAR := %IMMED 0;
        KEY_3 : [CLASS_S] PACKED ARRAY [$l7..$u7:INTEGER] OF CHAR := %IMMED 0;
        KEY_4 : [CLASS_S] PACKED ARRAY [$l8..$u8:INTEGER] OF CHAR := %IMMED 0;
        KEY_5 : [CLASS_S] PACKED ARRAY [$l9..$u9:INTEGER] OF CHAR := %IMMED 0;
        KEY_6 : [CLASS_S] PACKED ARRAY [$l10..$u10:INTEGER] OF CHAR := %IMMED 0;
        KEY_7 : [CLASS_S] PACKED ARRAY [$l11..$u11:INTEGER] OF CHAR := %IMMED 0;
        KEY_8 : [CLASS_S] PACKED ARRAY [$l12..$u12:INTEGER] OF CHAR := %IMMED 0;
        KEY_9 : [CLASS_S] PACKED ARRAY [$l13..$u13:INTEGER] OF CHAR := %IMMED 0;
        KEY_10 : [CLASS_S] PACKED ARRAY [$l14..$u14:INTEGER] OF CHAR := %IMMED 0) : INTEGER; EXTERNAL;

[asynchronous,global]
function callback(line : [class_s] packed array[lower..upper:integer] of char;
                  flag : integer;
                  var ctx : help_context;
                  level : integer) : integer;

var
   i : integer;
   temp : pstr;

begin
   if flag = HLP$M_KEYNAMLIN then begin
      (* nothing *)
   end else if flag = HLP$M_OTHERINFO then begin
      if (length(line) > 0) and (index(line, 'Additional information available') = 0) then begin
         temp := '';
         for i := 1 to length(line) do begin
            if line[i] <> ' ' then begin
               temp := temp + line[i];
            end else begin
               if length(temp) > 0 then begin
                  ctx.nsubtopics := ctx.nsubtopics + 1;
                  ctx.subtopics[ctx.nsubtopics] := temp;
                  temp := '';
               end;
            end;
         end;
         if length(temp) > 0 then begin
            ctx.nsubtopics := ctx.nsubtopics + 1;
            ctx.subtopics[ctx.nsubtopics] := temp;
         end;
      end;
   end else begin
      if length(ctx.helptext) + length(line) < 30000 then begin
         ctx.helptext := ctx.helptext + ' ' + line;
      end;
   end;
   callback := SS$_NORMAL;
end;

var
   stat : integer;
   libix : unsigned;
   ctx : help_context;
   temp : path;
   todo : queue;
   totalpath : pstr;
   i : integer;
   solr : solr_ctxptr;
   id : integer;

begin
   solr := psolr_setup('arnepc5', 8888, 'vmshelp');
   psolr_delete(solr, '*:*');
   id := 1;
   stat := lbr$ini_control(libix, LBR$C_READ, LBR$C_TYP_HLP);
   if not(odd(stat)) then begin
      writeln('stat = ', stat:1);
      halt;
   end;
   stat := lbr$open(libix, 'SYS$HELP:HELPLIB.HLB');
   if not(odd(stat)) then begin
      writeln('stat = ', stat:1);
      halt;
   end;
   temp.npathelms := 0;
   todo.nqueueelms := 1;
   todo.queueelms[todo.nqueueelms] := temp;
   while todo.nqueueelms > 0 do begin
      ctx.nsubtopics := 0;
      ctx.helptext := '';
      case(todo.queueelms[todo.nqueueelms].npathelms) of
         0 : stat := lbr$get_help_hack(libix, 80, callback, ctx);
         1 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1]);
         2 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2]);
         3 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3]);
         4 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3],
                                       todo.queueelms[todo.nqueueelms].pathelms[4]);
         5 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3],
                                       todo.queueelms[todo.nqueueelms].pathelms[4],
                                       todo.queueelms[todo.nqueueelms].pathelms[5]);
         6 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3],
                                       todo.queueelms[todo.nqueueelms].pathelms[4],
                                       todo.queueelms[todo.nqueueelms].pathelms[5],
                                       todo.queueelms[todo.nqueueelms].pathelms[6]);
         7 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3],
                                       todo.queueelms[todo.nqueueelms].pathelms[4],
                                       todo.queueelms[todo.nqueueelms].pathelms[5],
                                       todo.queueelms[todo.nqueueelms].pathelms[6],
                                       todo.queueelms[todo.nqueueelms].pathelms[7]);
         8 : stat := lbr$get_help_hack(libix, 80, callback, ctx,
                                       todo.queueelms[todo.nqueueelms].pathelms[1],
                                       todo.queueelms[todo.nqueueelms].pathelms[2],
                                       todo.queueelms[todo.nqueueelms].pathelms[3],
                                       todo.queueelms[todo.nqueueelms].pathelms[4],
                                       todo.queueelms[todo.nqueueelms].pathelms[5],
                                       todo.queueelms[todo.nqueueelms].pathelms[6],
                                       todo.queueelms[todo.nqueueelms].pathelms[7],
                                       todo.queueelms[todo.nqueueelms].pathelms[8]);
         otherwise begin
            writeln('level > 8');
            halt;
         end;
      end;
      if not(odd(stat)) then begin
         writeln('stat = ', stat:1);
         halt;
      end;
      totalpath := '';
      for i := 1 to todo.queueelms[todo.nqueueelms].npathelms do begin
         if i > 1 then totalpath := totalpath + ' ';
         totalpath := totalpath + todo.queueelms[todo.nqueueelms].pathelms[i];
      end;
      psolr_insert(solr, id, 'path', totalpath, 'helptext', ctx.helptext);
      if (id mod 100) = 0 then begin
         writeln(id:1,' ',totalpath);
      end;
      id := id + 1;
      temp := todo.queueelms[todo.nqueueelms];
      temp.npathelms := temp.npathelms + 1;
      todo.nqueueelms := todo.nqueueelms - 1;
      for i := ctx.nsubtopics downto 1 do begin
         todo.nqueueelms := todo.nqueueelms + 1;
         temp.pathelms[temp.npathelms] := ctx.subtopics[i];
         todo.queueelms[todo.nqueueelms] := temp;
      end;
   end;
   stat := lbr$close(libix);
   if not(odd(stat)) then begin
      writeln('stat = ', stat:1);
      halt;
   end;
end.
